<template>
    <div class="text-end px-2">
        <button alt="Guardar" title="Guardar" type="button" class="btn btn-guardar mt-1 mx-2 fs-3" @click="guardar()">
            <i class="fa-solid fa-floppy-disk "></i>
        </button>
    </div>
        <div class="d-md-flex align-items-center flex-wrap justify-content-start p-4 contenedorPrincipal mt-3">
            

                <div class="col-2 ">
                    <label class="form-label me-2">Fecha Desde:</label>
                    <input type="date" v-model="data.fecha_desde" class="d-block" id="f_desde" autocomplete="off"/>
                </div>
                <div class="col-2">
                    <label class="form-label me-2">Fecha Hasta:</label>
                    <input type="date" v-model="data.fecha_hasta" class=" d-block " id="f_hasta" autocomplete="off"/>
                </div>
                <div class="col-3 ">
                    <label class="form-label ">Cargo:</label>
                    <auto-complete class="" v-model="data.cargo" :elements="cuposStore.listadoCargos"
                        placeholder="Seleccionar cargo" :minLength="3" :disabled="!esAlta" :initKey="data.cargo?.key" />
                </div>
                <div class="col-3 ms-md-3">
                    <label class="form-label ">Monto Anual:</label>
                    <!-- <input type="number" v-model.number="data.monto" class="form-control" id="doc-solicitante" /> -->
                    <InputCurrency class="form-control p-0 px-2" v-model="data.monto" :disabled="false" />
                </div>

                <div class="col-4 mt-2">
                    <label class="form-label">Observaciones:</label>
                    <textarea v-model="data.observaciones" class="form-control" id="dependencia-solicitante"></textarea>
                </div>
         
            </div>       
     
  
</template>

<script setup lang="ts">
//librerias
import { reactive, computed, onMounted, watch } from "vue";
import { useRoute, useRouter } from "vue-router";
import http from "@/http";
import { loading, urlApi, isEmpty } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";
//import { AxiosError } from "axios";
import type { AxiosResponse, AxiosError } from "axios";
import { AutoComplete, InputCurrency } from "@hcd-bsas/vue3-components";
//Entities
import type Cargo from "@/entities/Cupos/Cargo";
import type Cupo from "@/entities/Cupos/Cupo";
// Stores
import { useCuposStore } from "@/stores/Cupos/cupos";
import { useConfigStore } from "@/stores/configgral";
//component



const cuposStore = useCuposStore();
const configStore = useConfigStore();

const router = useRouter();
const route = useRoute();

var data = reactive({
    anio: "" as string,
    f_periodo: "" as string,
    fecha_desde: "" as string,
    fecha_hasta: "" as string,
    monto: 0 as number,
    observaciones: "" as string,
    cupo: null as Cupo | null,
    cargo: null as Cargo | null,

});

const esAlta = computed(() => {
    return isEmpty(route.params.id) ? true : false;
});

/* const enableComponent = computed(() => {
    if (data.perfilactualiza == 3 && data.perfilactualiza == data.usuarioHabilitado?.id_perfil) {
        return false;
    } else { return true; }
}); */

/* const bla =  watch(() => data.perfilactualiza,(newValue :any , oldValue: any)=>{
     if (newValue == 3 ){
        //cargarlista ?
     }
 });*/

/* async function guardar() {



    if (!esAlta) {
        console.log("Con ID");
    } else {
        console.log("SIN ID");
    }
} */
class validateForm { flag: boolean = false; mensaje!: string };
function validar(): validateForm {

    if (data.fecha_desde == "" || data.fecha_hasta == "") {
        return {
            flag: false,
            mensaje: "Fechas en Blanco"
        };
    }
    //validar que fecha desde y hasta el año  sea = al periodo activo ( data.anio )
    let anio_desde = data.fecha_desde.substring(0, 4);
    let anio_hasta = data.fecha_hasta.substring(0, 4);
    if (anio_desde != data.anio || anio_hasta != data.anio) {
        return {
            flag: false,
            mensaje: "Año Diferente al Periodo Activo"
        };
    }

    if (data.cargo == null) {
        return {
            flag: false,
            mensaje: "No Selecciono Cargo"
        };
    }

    if (data.fecha_desde >= data.fecha_hasta) {
        return {
            flag: false,
            mensaje: "Fecha Desde No puede Ser Superior a Fecha Hasta"
        };
    }

    if (data.monto < 0 || data.monto == null) { //esto falta el filtro ver tmb la librery
        return {
            flag: false,
            mensaje: "Indique un Monto Superior a 0"
        };
    }

    return {
        flag: true,
        mensaje: ""
    };

}


async function guardar() {

    var { flag, mensaje } = validar();

/*     const swal_error: SweetAlertOptions<any, any> = {
        icon: "error",
        title: "Error",
        html: "",
    } */

    if (flag == true) {
        loading.show();
        var rta = await http.post(urlApi + "addCupoSolicitanteGrabar", {
            f_periodo: data.f_periodo,
            id_cargo: data.cargo?.id_cargo,
            id_tabla_sol: data.cargo?.id_tabla_sol,
            monto: data.monto,
            f_desde: data.fecha_desde,
            f_hasta: data.fecha_hasta,
            tipo_transf:'C',//tipo transf falta
            observaciones: data.observaciones,
        }).then(async () => {
            router.push({
                name: "inicioCuposPorCargo",
            });
            Swal.fire({
                icon: "success",
                text: "Se grabo el Cupo.",
            })
            loading.hide();
        }).catch(function (error) {
            console.log(error);
            Swal.fire({
                icon: "error",
                text: error.response.data.message.replace("Error al ejecutar la operación solicitada en la base de datos. Por favor, avise al Administrador. Mensaje de la excepción de Microsoft SQL Server:",""),
            });
            loading.hide();
            /*if  (error.response) {
                // Request made and server responded
                swal_error.html =
                    error.message +
                    " (" +
                    error.code +
                    ")." +
                    "<br />" +
                    error.response.data.substring(
                        error.response.data.indexOf("<h2>") + 4,
                        error.response.data.indexOf("</h2>")
                    );
                console.log("Error: request made and server responded");
                console.log(swal_error.html);
                console.log(error.response);
            } else if (error.request) {
                // The request was made but no response was received
                swal_error.html =
                    "Error desconocido. Por favor, avise al Administrador.";
                console.log("Error: the request was made but no response was received");
                console.log(error.request);
            } else {
                // Something happened in setting up the request that triggered an Error
                swal_error.html =
                    "Error desconocido. Por favor, avise al Administrador.";
                console.log(
                    "Error: something happened in setting up the request that triggered an error"
                );
                console.log(error);
            }
            loading.hide();
            Swal.fire(swal_error );*/
        });
    } else {
        Swal.fire({
            icon: "error",
            text: mensaje,
        });
    }
}


onMounted(async () => {

    loading.show();

    await configStore.updateListadoPeriodo();
    data.anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
    data.f_periodo = configStore.listadoPeriodoActivo[0]?.f_periodo;
    data.fecha_desde = data.anio + "-03-01";
    data.fecha_hasta = data.anio + "-12-31";

    await cuposStore.updateListadoCargos({
        periodo: data.anio,
        viene_de: 'B'
    });

    /* if (!esAlta.value) {
        await loadUsuario( Number (route.params.id));
      } */
    loading.hide();
});


</script>
